package BankGUI;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.JTextArea;

public class Controller {
	
	// Feldvariablen fr File, Lese- und Schreibe Streams
	private File logFile;
	private BufferedReader reader = null;
	private BufferedWriter writer = null;
	private final String filename = "logDatei.txt";
	
	private DecodingReader decode = null;
	
	public Controller(){
		// Log-Datei:
		logFile = new File(filename);
		if(!logFile.exists()){		
			try {
				// anlegen, falls nicht existiert.
				logFile.createNewFile();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	
	
	public void save(String msg){
		
		try {
			writer = new BufferedWriter(new FileWriter(this.logFile,true)); 

			writer.write(msg);
			
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}finally{
			if (writer!=null)
				try {;
					writer.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
		}
	}
	
	public void show_normal(JTextArea txt_area){
		
		System.out.println("Printing Log-File undecoded...");
		try {
			reader = new BufferedReader(new FileReader(this.logFile));
			String line; 
			while((line=reader.readLine())!=null){
				txt_area.append(line+"\n");
			}
			reader.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}finally{
			if(reader!=null){
				try {
					reader.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}
	
	// Methode zum Anzeigen der Log-Datei mit vorheriger Entschlsselung
	public void show_encoded(JTextArea txt_area){
		
		System.out.println("Printing decoded Log-File");
		try {
			reader = new BufferedReader(new FileReader(this.logFile));
			
			// FilterReader instanziieren und den BufferedReader mitgeben. 
			decode = new DecodingReader(reader);
			
			int c;
			while((c = decode.read())>=0)
				txt_area.append(String.valueOf((char) c));
			
			// Wieder schlieen
			decode.close();
			reader.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}finally{
			if(reader!=null){
				try {
					decode.close();
					reader.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}	
	}
}
