package BankGUI;

import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

public class Gui extends JFrame{
	
	private static final long serialVersionUID = 1L;
	private JButton save_btn, btn1, btn2;
	private JTextArea txt_ar;
	private Controller c;
	
	public Gui(Controller c){
		
		this.c = c;
		this.setTitle("Meine Bank");		
		this.setSize(500, 300);

		this.txt_ar = new JTextArea(6, 30);
		JScrollPane scrollPane = new JScrollPane(this.txt_ar); 
		this.save_btn = new JButton("Speichern");
		
		this.save_btn.addActionListener((ActionEvent e)-> {
			c.save(txt_ar.getText());
			JOptionPane.showMessageDialog(this, "Gespeichert");
			txt_ar.setText("");		
		});

		this.btn1 = new JButton("Normal anzeigen");
		this.btn1.addActionListener((ActionEvent e) ->{
			this.txt_ar.setText("");
			this.c.show_normal(this.txt_ar);
		});
		
		this.btn2 = new JButton("Verschlsselt anzeigen");
		this.btn2.addActionListener((ActionEvent e) ->{
			this.txt_ar.setText("");
			c.show_encoded(this.txt_ar);
		});
				
		JPanel button_panel = new JPanel();
		
		button_panel.setLayout(new FlowLayout(FlowLayout.CENTER));
		button_panel.add(save_btn);
		button_panel.add(btn1);
		button_panel.add(btn2);
		
		this.setLayout(new GridLayout(3,1));
		
		this.add(new JLabel("Meine Transaktionen:"));
		this.add(scrollPane);
		this.add(button_panel);
		
		this.setVisible(true);
	}
}
